using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Example_2_1
{
  public partial class frmSavings : Form
  {
    public frmSavings()
    {
      InitializeComponent();
    }

    double deposit;
    double interest;
    double months;
    double final;

    private void btnCalculate_Click(object sender, EventArgs e)
    {
      double intRate;
      double finalCompute, intChange;
      int intDirection;
      // Determine which box is blank
      // Compute that missing value and put in text box
      if (txtDeposit.Text.Trim() == "")
      {
        // Deposit missing
        // read other values from text boxes
        interest = Convert.ToDouble(txtInterest.Text);
        intRate = interest / 1200;
        months = Convert.ToDouble(txtMonths.Text);
        final = Convert.ToDouble(txtFinal.Text);
        if (interest == 0)
        {
          deposit = final / months;
        }
        else
        {
          deposit = final / ((Math.Pow(1 + intRate, months) - 1) / intRate);
        }
        txtDeposit.Text = String.Format("{0:f2}", deposit);
      }
      else if (txtInterest.Text.Trim() == "")
      {
        // Interest missing - requires iterative solution
        // read other values from text boxes
        deposit = Convert.ToDouble(txtDeposit.Text);
        months = Convert.ToDouble(txtMonths.Text);
        final = Convert.ToDouble(txtFinal.Text);
        // intChange is how much we change interest each step
        // intDirection is direction (+ or -) we change interest
        interest = 0;
        intChange = 1;
        intDirection = 1;
        do
        {
          interest += intDirection * intChange;
          intRate = interest / 1200;
          finalCompute = deposit * (Math.Pow(1 + intRate, months) - 1) / intRate;
          if (intDirection == 1)
          {
            if (finalCompute > final)
            {
              intDirection = -1;
              intChange /= 10;
            }
          }
          else
          {
            if (finalCompute < final)
            {
              intDirection = 1;
              intChange /= 10;
            }
          }
        }
        while (Math.Abs(finalCompute - final) > 0.005);
        txtInterest.Text = String.Format("{0:f2}", interest);
      }
      else if (txtMonths.Text.Trim() == "")
      {
        // Months missing
        // read other values from text boxes
        deposit = Convert.ToDouble(txtDeposit.Text);
        interest = Convert.ToDouble(txtInterest.Text);
        intRate = interest / 1200;
        final = Convert.ToDouble(txtFinal.Text);
        if (interest == 0)
        {
          months = final / deposit;
        }
        else
        {
          months = Math.Log(final * intRate / deposit + 1) / Math.Log(1 + intRate);
        }
        txtMonths.Text = String.Format("{0:f2}", months);
      }
      else if (txtFinal.Text.Trim() == "")
      {
        // Final value missing
        // read other values from text boxes
        deposit = Convert.ToDouble(txtDeposit.Text);
        interest = Convert.ToDouble(txtInterest.Text);
        intRate = interest / 1200;
        months = Convert.ToDouble(txtMonths.Text);
        if (interest == 0)
        {
          final = deposit * months;
        }
        else
        {
          final = deposit * (Math.Pow(1 + intRate, months) - 1) / intRate;
        }
        txtFinal.Text = String.Format("{0:f2}", final);
      }
    }

    private void btnExit_Click(object sender, EventArgs e)
    {
      this.Close();
    }
    private void txtDeposit_KeyPress(object sender, KeyPressEventArgs e)
    {
      // only allow numbers, a single decimal point, backspace  or enter
      if ((e.KeyChar >= '0' && e.KeyChar <= '9') || (int)e.KeyChar == 8)
      {
        // acceptable keystrokes 
        e.Handled = false;
      }
      else if ((int)e.KeyChar == 13)
      {
        // enter key - move to next box
        txtInterest.Focus();
      }
      else if (e.KeyChar == '.')
      {
        // check for existence of decimal point
        if (txtDeposit.Text.IndexOf(".") == -1)
        {
          e.Handled = false;
        }
        else
        {
          e.Handled = true;
        }
      }
      else
      {
        e.Handled = true;
      }
    }
    private void txtInterest_KeyPress(object sender, KeyPressEventArgs e)
    {
      // only allow numbers, a single decimal point, backspace  or enter    
      if ((e.KeyChar >= '0' && e.KeyChar <= '9') || (int)e.KeyChar == 8)
      {
        // acceptable keystrokes 
        e.Handled = false;
      }
      else if ((int)e.KeyChar == 13)
      {
        // enter key - move to next box
        txtMonths.Focus();
      }
      else if (e.KeyChar == '.')
      {
        // check for existence of decimal point
        if (txtDeposit.Text.IndexOf(".") == -1)
        {
          e.Handled = false;
        }
        else
        {
          e.Handled = true;
        }
      }
      else
      {
        e.Handled = true;
      }
    }
    private void txtMonths_KeyPress(object sender, KeyPressEventArgs e)
    {
      // only allow numbers, a single decimal point, backspace  or enter
      if ((e.KeyChar >= '0' && e.KeyChar <= '9') || (int)e.KeyChar == 8)
      {
        // acceptable keystrokes 
        e.Handled = false;
      }
      else if ((int)e.KeyChar == 13)
      {
        // enter key - move to calculate button
        txtFinal.Focus();
      }
      else
      {
        e.Handled = true;
      }
    }

    private void txtFinal_KeyPress(object sender, KeyPressEventArgs e)
    {
      // only allow numbers, a single decimal point, backspace  or enter    
      if ((e.KeyChar >= '0' && e.KeyChar <= '9') || (int)e.KeyChar == 8)
      {
        // acceptable keystrokes 
        e.Handled = false;
      }
      else if ((int)e.KeyChar == 13)
      {
        // enter key - move to calculate button
        btnCalculate.Focus();
      }
      else if (e.KeyChar == '.')
      {
        // check for existence of decimal point
        if (txtDeposit.Text.IndexOf(".") == -1)
        {
          e.Handled = false;
        }
        else
        {
          e.Handled = true;
        }
      }
      else
      {
        e.Handled = true;
      }
    }

    private void btnClear_Click(object sender, EventArgs e)
    {
      // blank out text boxes
      txtDeposit.Text = "";
      txtInterest.Text = "";
      txtMonths.Text = "";
      txtFinal.Text = "";
      txtDeposit.Focus();
    }

  }
}